#include <stdlib.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** Depth Peeling ̃C[
*/
static int layer = 0;

/*
** 
*/
static const GLfloat lightpos[] = { 4.0, 9.0, 5.0, 1.0 }; /* ʒu@@@@@@@ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ڌx@@@@ */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* x@@@@ */

/*
** eNX`
*/
#define TEXWIDTH  512                                     /* eNX`̕@@ */
#define TEXHEIGHT 512                                     /* eNX`̍@ */

/*
** 
*/
static void init(void)
{
  /* eNX`̊蓖ā|̃eNX`ÕfvXobt@ƂĎg */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, TEXWIDTH, TEXHEIGHT, 0,
    GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, 0);
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

  /* ރ|S̃eNX`Wl̂qƃeNX`Ƃ̔rs悤ɂ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_COMPARE_R_TO_TEXTURE);
  
  /* q̒leNX`̒l𒴂Ă^itOg`j */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC, GL_GREATER);
  
  /* řʂAt@lƂē */
  glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_ALPHA);
  
  /* At@eXg̔r֐ilj */
  glAlphaFunc(GL_GEQUAL, 0.5f);

  /* eNX`WɎ_Wnɂ镨̂̍Wlp */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_Q, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);

  /* eNX`Ŵ܂ (S, T, R, Q) Ɏg */
  static const GLdouble genfunc[][4] = {
    { 1.0, 0.0, 0.0, 0.0 },
    { 0.0, 1.0, 0.0, 0.0 },
    { 0.0, 0.0, 1.0, 0.0 },
    { 0.0, 0.0, 0.0, 1.0 },
  };
  glTexGendv(GL_S, GL_EYE_PLANE, genfunc[0]);
  glTexGendv(GL_T, GL_EYE_PLANE, genfunc[1]);
  glTexGendv(GL_R, GL_EYE_PLANE, genfunc[2]);
  glTexGendv(GL_Q, GL_EYE_PLANE, genfunc[3]);

  /* ݒ */
  glClearColor(0.3f, 0.3f, 1.0f, 1.0f);
  glEnable(GL_DEPTH_TEST);
  
  /* ̏ݒ */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);

  /* Polygon Offset ̐ݒ */
  glPolygonOffset(1.0f, 1.0f);
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

/* gbN{[p֐̐錾 */
#include "trackball.h"

/* V[`֐̐錾 */
#include "scene.h"

static void display(void)
{
  GLdouble projection[16]; /* ϊs̕ۑp */
  int i;

  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* _̈ʒuݒ肷î̕Ɉړj*/
  glTranslated(0.0, 0.0, -10.0);
  
  /* gbN{[̉]^ */
  glMultMatrixd(trackballRotation());
  
  /* ̈ʒuݒ肷 */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* eNX`ϊsݒ肷 */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  
  /* eNX`W [-1,1] ͈̔͂ [0,1] ͈̔͂Ɏ߂ */
  glTranslated(0.5, 0.5, 0.5);
  glScaled(0.5, 0.5, 0.5);
  
  /* ݂̓ϊso */
  glGetDoublev(GL_PROJECTION_MATRIX, projection);

  /* ϊseNX`ϊsɐݒ肷 */
  glMultMatrixd(projection);

  /* fr[ϊsɖ߂ */
  glMatrixMode(GL_MODELVIEW);
  
  /* fvXobt@OŃNA */
  glClearDepth(0.0);
  glClear(GL_DEPTH_BUFFER_BIT);

  /* fvXobt@̏lPɖ߂ */
  glClearDepth(1.0);

  /* eNX`}bsOƃeNX`W̎Lɂ */
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  glEnable(GL_TEXTURE_GEN_Q);
  
  /* At@eXgLɂ */
  glEnable(GL_ALPHA_TEST);

  /* Polygon Offset Lɂ */
  glEnable(GL_POLYGON_OFFSET_FILL);

  for (i = 0; i <= layer; ++i) {

    /* fvXobt@fvXeNX`ɃRs[ */
    glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 0, 0, TEXWIDTH, TEXHEIGHT);

    /* t[obt@ƃfvXobt@NA */
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    /* V[`悷 */
    scene();
  }  
    
  /* Polygon Offset 𖳌ɂ */
  glDisable(GL_POLYGON_OFFSET_FILL);

  /* At@eXg𖳌ɂ */
  glDisable(GL_ALPHA_TEST);

  /* eNX`}bsOƃeNX`W̎𖳌ɂ */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  glDisable(GL_TEXTURE_GEN_Q);
  glDisable(GL_TEXTURE_2D);

  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* EBhETCY̊gk𐧌 */
  if (w != TEXWIDTH || h != TEXHEIGHT) {
    if (w != TEXWIDTH) w = TEXWIDTH;
    if (h != TEXHEIGHT) h = TEXHEIGHT;
    glutReshapeWindow(w, h);
  }

  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(40.0, (GLdouble)w / (GLdouble)h, 3.0, 15.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  if (key >= '0' && key <= '9') {
    /* '0'`'9' ̃L[ Depth Peeling ̃C[ύX */
    layer = key - '0';
    glutPostRedisplay();
  }
  else {
    switch (key) {
    case 'q':
    case 'Q':
    case '\033':
      /* ESC  q  Q ^CvI */
      exit(0);
    default:
      break;
    }
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitWindowSize(TEXWIDTH, TEXHEIGHT);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
